package com.cooliris.media;

/**
 * A pair of objects. Mostly auto-generated by Eclipse.
 */
public class Pair<S, T> {
    public final S first;
    public final T second;

    public Pair(S first, T second) {
        this.first = first;
        this.second = second;
    }

    public static <S, T> Pair<S, T> create(S first, T second) {
        return new Pair<S, T>(first, second);
    }

    @Override
    public int hashCode() {
        final int PRIME = 31;
        int result = 1;
        result = PRIME * result + ((first == null) ? 0 : first.hashCode());
        result = PRIME * result + ((second == null) ? 0 : second.hashCode());
        return result;
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Pair<S, T> other = (Pair) obj;
        if (first == null && other.first != null) {
            return false;
        } else if (!first.equals(other.first)) {
            return false;
        }
        if (second == null && other.second != null) {
            return false;
        } else if (!second.equals(other.second)) {
            return false;
        }
        return true;
    }

}
